# OctetString type

class pyasn1.type.univ.OctetString(value=NoValue(), tagSet=TagSet(), subtypeSpec=ConstraintsIntersection(), encoding='iso-8859-1', binValue=NoValue(), hexValue=NoValue())

  Create OctetString schema or value object.

  OctetString class is based on `SimpleAsn1Type`, its objects are immutable and duck-type Python 2 `str` or Python 3 `bytes`. When used in Unicode context, OctetString type assumes “iso-8859-1” serialisation.

  Keyword Arguments

    - value (`unicode`, `str`, `bytes` or OctetString object) – class:str (Python 2) or `bytes` (Python 3), alternatively class:unicode object (Python 2) or `str` (Python 3) representing character string to be serialised into octets (note encoding parameter) or OctetString object. If value is not given, schema object will be created.

    - tagSet (`TagSet`) – Object representing non-default ASN.1 tag(s)

    - subtypeSpec (`ConstraintsIntersection`) – Object representing non-default ASN.1 subtype constraint(s). Constraints verification for OctetString type occurs automatically on object instantiation.

    - encoding (`str`) – Unicode codec ID to encode/decode `unicode` (Python 2) or `str` (Python 3) the payload when OctetString object is used in text string context.

    - binValue (`str`) – Binary string initializer to use instead of the value. Example: ‘10110011’.

    - hexValue (`str`) – Hexadecimal string initializer to use instead of the value. Example: ‘DEADBEEF’.

  Raises

    ValueConstraintError, PyAsn1Error – On constraint violation or bad initializer.

  Examples

      class Icon(OctetString):
          '''
          ASN.1 specification:

          Icon ::= OCTET STRING

          icon1 Icon ::= '001100010011001000110011'B
          icon2 Icon ::= '313233'H
          '''
      icon1 = Icon.fromBinaryString('001100010011001000110011')
      icon2 = Icon.fromHexString('313233')

  Note

  The OctetString type models an arbitrary string of octets (eight-bit numbers), not printable text string.

  clone(value=NoValue(), tagSet=TagSet(), subtypeSpec=ConstraintsIntersection(), encoding='iso-8859-1')

    Create a modified version of OctetString schema or value object.

    The clone() method accepts the same set arguments as OctetString class takes on instantiation except that all arguments of the clone() method are optional.

    Whatever arguments are supplied, they are used to create a copy of self taking precedence over the ones used to instantiate self.

    Note

    Due to the immutable nature of the OctetString object, if no arguments are supplied, no new OctetString object will be created and self will be returned instead.

  subtype(value=NoValue(), implicitTag=Tag(), explicitTag=Tag(), subtypeSpec=ConstraintsIntersection(), encoding='iso-8859-1')

    Create a specialization of OctetString schema or value object.

    The subtype relationship between ASN.1 types has no correlation with subtype relationship between Python types. ASN.1 type is mainly identified by its tag(s) (`TagSet`) and value range constraints (`ConstraintsIntersection`). These ASN.1 type properties are implemented as OctetString attributes.

    The subtype() method accepts the same set arguments as OctetString class takes on instantiation except that all parameters of the subtype() method are optional.

    With the exception of the arguments described below, the rest of supplied arguments they are used to create a copy of self taking precedence over the ones used to instantiate self.

    The following arguments to subtype() create a ASN.1 subtype out of OctetString type:

    Other Parameters

      - implicitTag (`Tag`) – Implicitly apply given ASN.1 tag object to self’s `TagSet`, then use the result as new object’s ASN.1 tag(s).

      - explicitTag (`Tag`) – Explicitly apply given ASN.1 tag object to self’s `TagSet`, then use the result as new object’s ASN.1 tag(s).

      - subtypeSpec (`ConstraintsIntersection`) – Add ASN.1 constraints object to one of the self’s, then use the result as new object’s ASN.1 constraints.

    Returns

      new instance of OctetString schema or value object

    Note

    Due to the immutable nature of the OctetString object, if no arguments are supplied, no new OctetString object will be created and self will be returned instead.

  tagSet = <TagSet object, tags 0:0:4>

    Set (on class, not on instance) or return a `TagSet` object representing ASN.1 tag(s) associated with OctetString type.

  subtypeSpec = <ConstraintsIntersection object>

    Set (on class, not on instance) or return a `ConstraintsIntersection` object imposing constraints on OctetString type initialization values.

  static fromBinaryString(value)

    Create a OctetString object initialized from a string of ‘0’ and ‘1’.

    Parameters

      value (`str`) – Text string like ‘1010111’

  static fromHexString(value)

    Create a OctetString object initialized from the hex string.

    Parameters

      value (`str`) – Text string like ‘DEADBEEF’

  property isValue

    Indicate that OctetString object represents ASN.1 value.

    If isValue is `False` then this object represents just ASN.1 schema.

    If isValue is `True` then, in addition to its ASN.1 schema features, this object can also be used like a Python built-in object (e.g. `int`, `str`, `dict` etc.).

    Returns

      `bool` – `False` if object represents just ASN.1 schema. `True` if object represents ASN.1 schema and can be used as a normal value.

    Note

    There is an important distinction between PyASN1 schema and value objects. The PyASN1 schema objects can only participate in ASN.1 schema-related operations (e.g. defining or testing the structure of the data). Most obvious uses of ASN.1 schema is to guide serialisation codecs whilst encoding/decoding serialised ASN.1 contents.

    The PyASN1 value objects can additionally participate in many operations involving regular Python objects (e.g. arithmetic, comprehension etc).

  isSameTypeWith(other, matchTags=True, matchConstraints=True)

    Examine OctetString type for equality with other ASN.1 type.

    ASN.1 tags (`tag`) and constraints (`constraint`) are examined when carrying out ASN.1 types comparison.

    Python class inheritance relationship is NOT considered.

    Parameters

      other (a pyasn1 type object) – Class instance representing ASN.1 type.

    Returns

      `bool` – `True` if other is OctetString type, `False` otherwise.

  isSuperTypeOf(other, matchTags=True, matchConstraints=True)

    Examine OctetString type for subtype relationship with other ASN.1 type.

    ASN.1 tags (`tag`) and constraints (`constraint`) are examined when carrying out ASN.1 types comparison.

    Python class inheritance relationship is NOT considered.

    Parameters

      other (a pyasn1 type object) – Class instance representing ASN.1 type.

    Returns

      `bool` – `True` if other is a subtype of OctetString type, `False` otherwise.

  property effectiveTagSet

    For OctetString type is equivalent to tagSet

  property tagMap

    Return a `TagMap` object mapping ASN.1 tags to ASN.1 objects within callee object.